
-- [FOLDER]의 PATH가 변경되면 하위 폴더의 PATH도 같이 수정한다. (2019.04.01 Eric)
-- PRAGMA recursive_triggers = ON;
-- File에서
-- mrl과 path가 같은 경우(iOS 경우 Document) mrl과 path를 같이 수정해 주고,
-- 다른 경우 (CameraRoll)는 mrl만 수정해 준다.
--CREATE TRIGGER folder_name_change AFTER UPDATE OF path ON Folder
--BEGIN
--	UPDATE Folder SET path = new.path || substr(path, LENGTH(old.path)+1)  WHERE path like (old.path || "/%") AND id_folder <> new.id_folder ;
--	UPDATE File SET mrl = new.path || substr(mrl, LENGTH(old.path) + 1), path = new.path || substr(mrl, LENGTH(old.path) + 1)
--	        WHERE mrl like (old.path || "/%") AND mrl = path;
--	UPDATE File SET mrl = new.path || substr(mrl, LENGTH(old.path) + 1) where mrl like (old.path || "/%") AND mrl <> path;
--END;

--    FROM Folder
--    WHERE path =  substr(rtrim(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1)
--    , replace(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1) , '/', ''))
--    ,1,length(rtrim(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1)
--    , replace(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1) , '/', '')))-1);
----------------------------------------------------------------------------------------------------
-- [FOLDER] [RECURSIVE] 폴더가 추가되면 상위 폴더를 자동으로 추가하고, parent_id에 추가해 준다.
-- 20190513 : 만약 디바이스가 Network Device 면 하위 폴더를 추가하지 않는다.
CREATE Trigger sub_folder_maker After Insert on Folder
    WHEN new.is_root <> 1 AND new.parent_id IS NULL
        AND EXISTS(SELECT id_device FROM Device Where new.device_id = id_device AND is_network = 0)
BEGIN
    INSERT OR IGNORE INTO Folder (path, name, device_id, is_removable)
        SELECT substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1),
            replace(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1),
            rtrim(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1),
            replace(substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1), '/', '')), ''),
            new.device_id, new.is_removable;

    UPDATE Folder SET parent_id = (SELECT id_folder FROM Folder WHERE path = substr(rtrim(new.path, replace(new.path, '/', '')),1,length(rtrim(new.path, replace(new.path, '/', '')))-1))
        WHERE id_folder = new.id_folder;
END;

----------------------------------------------------------------------------------------------------
-- [FILE] [[FOLDER]RECURSIVE] 파일이 추가되면 상위 폴더를 자동으로 추가하고, folder_id를 추가해 준다.
-- 20190513 : 만약 디바이스가 Network Device 면 폴더를 추가하지 않는다.
CREATE TRIGGER file_folder_maker After Insert on File WHEN new.folder_id IS NULL
     AND EXISTS(SELECT id_device FROM Device Where new.device_id = id_device AND is_network = 0)
BEGIN
    INSERT OR IGNORE INTO Folder (path, name, device_id, is_removable)
    SELECT substr(rtrim(new.mrl, replace(new.mrl, '/', '')),1,length(rtrim(new.mrl, replace(new.mrl, '/', '')))-1),
        replace(substr(rtrim(new.mrl, replace(new.mrl, '/', '')),1,length(rtrim(new.mrl, replace(new.mrl, '/', '')))-1),
        rtrim(substr(rtrim(new.mrl, replace(new.mrl, '/', '')),1,length(rtrim(new.mrl, replace(new.mrl, '/', '')))-1),
        replace(substr(rtrim(new.mrl, replace(new.mrl, '/', '')),1,length(rtrim(new.mrl, replace(new.mrl, '/', '')))-1), '/', '')), ''),
        new.device_id , new.is_removable;

    UPDATE File SET folder_id = (SELECT id_folder FROM Folder WHERE path = substr(rtrim(new.mrl, replace(new.mrl, '/', '')),1,length(rtrim(new.mrl, replace(new.mrl, '/', '')))-1))
	WHERE id_file = new.id_file;
END;



----------------------------------------------------------------------------------------------------
-- [FOLDER] [RECURSIVE] 폴더명이 변경되면 해당 폴더에 해당하는 모든 파일의 경로를 수정하고, 하위 폴더의 PATH를 수정한다.
CREATE TRIGGER folder_name_change AFTER UPDATE OF path ON Folder
BEGIN
    UPDATE File SET mrl = new.path || substr(mrl, LENGTH(old.path) + 1)    WHERE folder_id = new.id_folder;
	UPDATE Folder SET path = new.path || substr(path, LENGTH(old.path)+1)  WHERE parent_id = new.id_folder;
END;

----------------------------------------------------------------------------------------------------
-- 파일의 MRL이 변경되면, 변경전 MRL과 PATH의 값이 같았다면 PATH 값을 동일한 MRL과 동일한 값으로 변경해 준다.
CREATE TRIGGER file_mrl_change AFTER UPDATE OF mrl ON File WHEN old.mrl = new.path
BEGIN
   UPDATE File SET path = new.mrl WHERE id_file = new.id_file;
END;

---- 폴더가 히든 상태의 폴더로 변경되었을때, 폴더/하위폴더/파일/하위폴더 파일들을 모두 히든 상태로 설정을 변경한다.
--CREATE TRIGGER change_to_hidden_folder AFTER UPDATE OF path ON Folder WHEN old.path NOT LIKE "%/."  AND new.path LIKE "%/."
--BEGIN
--    UPDATE Folder SET is_hidden = 1  WHERE id_folder = new.id_folder;
--	UPDATE Folder SET is_hidden = 1  WHERE path like (old.path || "/%");
--	UPDATE File SET is_hidden = 1 WHERE mrl like (old.path || "/%");
--END;
--
---- 폴더가 히든 상태에서 일반 상태로 변경 되었을때, 폴더/하위폴더/파일/하위폴더 파일들을 모두 일반 상태로 설정을 변경한다.
--CREATE TRIGGER change_to_visible_folder AFTER UPDATE OF path ON Folder WHEN old.path LIKE "%/."  AND new.path NOT LIKE "%/."
--BEGIN
--    UPDATE Folder SET is_hidden = 0  WHERE id_folder = new.id_folder;
--	UPDATE Folder SET is_hidden = 0  WHERE path like (old.path || "/%");
--	UPDATE File SET is_hidden = 0 WHERE mrl like (old.path || "/%");
--END;

----------------------------------------------------------------------------------------------------
-- [FOLDER] [RECURSIVE] 폴더의 히든 상태가 변경, 파일과 하위폴더들의 상태를 동일하게 변경한다.
-- HIDDEN 판단 기준은 파일/폴더명이 점(.)으로 시작하는 경우로 제한 한다.
CREATE TRIGGER change_hidden_folder AFTER UPDATE OF is_hidden ON Folder
BEGIN
	UPDATE Folder SET is_hidden = new.is_hidden  WHERE parent_id = new.id_folder AND path NOT LIKE "%/.%";
	UPDATE File SET is_hidden = new.is_hidden WHERE folder_id = new.id_folder AND mrl NOT LIKE "%/.%";
END;

----------------------------------------------------------------------------------------------------
-- [FILE] 파일의 히든상태가 변경되면 미디어의 상태도 변경한다
CREATE TRIGGER change_hidden_file AFTER UPDATE OF is_hidden ON File
BEGIN
    UPDATE Media SET is_hidden = new.is_hidden WHERE id_media = new.media_id;
END;

----------------------------------------------------------------------------------------------------
-- [DEVICE]의 is_present 가 변경되면 디바이스에 해당하는 모든 [MEDIA]의 is_present를 변경한다.
CREATE TRIGGER is_media_device_present AFTER UPDATE OF is_present ON Device
BEGIN
	UPDATE Media SET is_present=new.is_present WHERE device_id=new.id_device;
END;

----------------------------------------------------------------------------------------------------
-- [FILE] File이 삭제되면 Media도 삭제한다.
CREATE TRIGGER cascade_file_deletion AFTER DELETE ON File
BEGIN
	DELETE FROM Media
		WHERE (SELECT COUNT(id_file) FROM File WHERE media_id=old.media_id) = 0
			AND id_media=old.media_id;
END;

----------------------------------------------------------------------------------------------------
-- MEDIA 추가, 수정, 삭제 처리
----------------------------------------------------------------------------------------------------
-- [MEDIA] 미디어가 추가되면 미디어가 포함된 폴더의 nb_audio 와 nb_video의 갯수를 증가시킨다.
CREATE TRIGGER update_folder_nb_media_on_insert AFTER INSERT ON Media WHEN new.folder_id IS NOT NULL
BEGIN
	UPDATE Folder SET nb_audio = nb_audio + (CASE new.type WHEN 2 THEN 1 ELSE 0 END)
		,nb_video = nb_video + (CASE new.type WHEN 1 THEN 1 ELSE 0 END)
		WHERE id_folder = new.folder_id;
END;

----------------------------------------------------------------------------------------------------
-- [MEDIA] 앨범에 속하는 미디어의 is_present 값을 변경하면 [Artist]와 [Album]의 is_present 값을 증감 시킨다.
CREATE TRIGGER has_tracks_present AFTER UPDATE OF is_present ON Media WHEN new.subtype = 3
BEGIN
	UPDATE Artist SET is_present=is_present + (CASE new.is_present WHEN 0 THEN -1 ELSE 1 END)
		WHERE id_artist = (SELECT artist_id FROM AlbumTrack  WHERE media_id = new.id_media );

	UPDATE Album SET is_present=is_present + (CASE new.is_present WHEN 0 THEN -1 ELSE 1 END)
			WHERE id_album = (SELECT album_id FROM AlbumTrack WHERE media_id = new.id_media);
END;
----------------------------------------------------------------------------------------------------
-- [MEDIA] 미디어의 새로운 폴더ID가 NULL이 아니고, 타입이 이전과 다르다면 폴더의 nb_audio와 nb_video의 갯수를 증감시킨다.
CREATE TRIGGER update_folder_nb_media_on_update
    AFTER UPDATE ON Media
    WHEN new.folder_id IS NOT NULL AND old.type != new.type
BEGIN
	UPDATE Folder SET nb_audio = nb_audio + (CASE old.type WHEN 2 THEN -1 ELSE 0 END)+(CASE new.type WHEN 2 THEN 1 ELSE 0 END)
			,nb_video = nb_video + (CASE old.type WHEN 1 THEN -1 ELSE 0 END)+(CASE new.type WHEN 1 THEN 1 ELSE 0 END)
			WHERE id_folder = new.folder_id;
END;
----------------------------------------------------------------------------------------------------
-- [MEDIA] 미디어가 삭제되면 미디어가 포함되어 있던 폴더 안의 nb_audio와 nb_video의 갯수를 차감한다.
CREATE TRIGGER update_folder_nb_media_on_delete AFTER DELETE ON Media WHEN old.folder_id IS NOT NULL
BEGIN
	UPDATE Folder SET nb_audio = nb_audio + (CASE old.type WHEN 2 THEN -1 ELSE 0 END)
		,nb_video = nb_video + (CASE old.type WHEN 1 THEN -1 ELSE 0 END)
		WHERE id_folder = old.folder_id;
END;

----------------------------------------------------------------------------------------------------
-- [MEDIA]가 삭제되고, 상태가 is_present = 1 이면, Artist와 Album의 is_present 값을 감소 시킨다.
CREATE TRIGGER update_is_present_on_media_delete AFTER DELETE ON Media WHEN old.subtype = 3 AND old.is_present = 1
BEGIN
	UPDATE Artist SET is_present=is_present -1
		WHERE id_artist = (SELECT artist_id FROM AlbumTrack  WHERE media_id = old.id_media );

	UPDATE Album SET is_present=is_present -1
			WHERE id_album = (SELECT album_id FROM AlbumTrack WHERE media_id = old.id_media);
END;

----------------------------------------------------------------------------------------------------
-- ALBUMTRACK 추가, 수정, 삭제 처리
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK]이 추가되면 [ALBUM]의 Duration, nb_tracks, is_present 값을 증가 시킨다.
CREATE TRIGGER update_album_on_new_track AFTER INSERT ON AlbumTrack
BEGIN
	UPDATE Album
		SET duration = duration + new.duration, nb_tracks = nb_tracks + 1, is_present = is_present + 1
		WHERE id_album = new.album_id;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK]이 쟝르 ID를 가지고 등록되면, [GENRE]의 nb_tracks 값을 증가 시킨다. (앨범트랙보다 쟝르가 먼저 등록되어야 한다.)
CREATE TRIGGER update_genre_on_new_track AFTER INSERT ON AlbumTrack
    WHEN new.genre_id IS NOT NULL
BEGIN
	UPDATE Genre SET nb_tracks = nb_tracks + 1 WHERE id_genre = new.genre_id;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK]이 추가되면 [Artist]의 nb_tracks와 is_present 값을 증가 시킨다.
CREATE TRIGGER update_artist_on_new_track AFTER INSERT ON AlbumTrack
    WHEN new.artist_id IS NOT NULL
BEGIN
	UPDATE Artist
	    SET is_present = is_present + 1, nb_tracks = nb_tracks + 1
	    WHERE id_artist = new.artist_id;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK] 앨범 트랙이 삭제되면 쟝르의 nb_tracks 카운트를 감소 시키고, nb_tracks 값이 0이 되면 쟝르를 삭제한다.
CREATE TRIGGER update_genre_on_track_deleted AFTER DELETE ON AlbumTrack
    WHEN old.genre_id IS NOT NULL
BEGIN
	UPDATE Genre SET nb_tracks = nb_tracks - 1 WHERE id_genre = old.genre_id;
	DELETE FROM Genre WHERE nb_tracks = 0;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK] 레코드가 삭제되면, [ARTIST]의 nb_tracks 값을 감소 시킨다.
-- [ALBUMTRACK]은 [MEDIA]가 삭제 될 때 삭제된다. 따라서, update_is_present_on_media_delete 처리 한다.
-- 아티스트의 nb_tracks와 nb_albums 가 0인 [ARTIST]는 삭제한다.
CREATE TRIGGER has_track_remaining AFTER DELETE ON AlbumTrack
BEGIN
	UPDATE Artist
		SET nb_tracks = nb_tracks - 1
		WHERE id_artist = old.artist_id;
	DELETE FROM Artist WHERE id_artist = old.artist_id  AND nb_albums = 0  AND nb_tracks = 0;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUMTRACK]이 삭제되면 [ALBUM]의 nb_tracks, duration 값을 감소 시킨다.
-- [ALBUMTRACK]은 [MEDIA]가 삭제 될 때 삭제된다. 따라서, update_is_present_on_media_delete 처리 한다.
-- 만약 [ALBUM]의 nb_tracks 값이 0 이면 [ALBUM]을 삭제한다.
CREATE TRIGGER delete_album_track AFTER DELETE ON AlbumTrack
BEGIN
	UPDATE Album
		SET nb_tracks = nb_tracks - 1
		, duration = duration - old.duration
		WHERE id_album = old.album_id;
	DELETE FROM Album WHERE id_album=old.album_id AND nb_tracks = 0;
END;

----------------------------------------------------------------------------------------------------
-- ALBUM 추가, 수정, 삭제 처리
----------------------------------------------------------------------------------------------------
-- [ALBUM] 추가시 아티스트의 앨범 카운트 증가
CREATE TRIGGER update_nb_albums_on_insert_album AFTER INSERT ON Album
BEGIN
	UPDATE Artist SET nb_albums = nb_albums + 1 WHERE id_artist = new.artist_id;
END;
----------------------------------------------------------------------------------------------------
-- [ALBUM]의 삭제 시 [ARTIST]의 nb_albums 카운트를 감소 시키고,
-- [ARTIST]의 nb_albums와 nb_tracks가 0이면 [ARTIST]를 삭제한다.
CREATE TRIGGER has_album_remaining AFTER DELETE ON Album
BEGIN
	UPDATE Artist SET nb_albums = nb_albums - 1 WHERE id_artist = old.artist_id;
	DELETE FROM Artist WHERE id_artist = old.artist_id  AND nb_albums = 0  AND nb_tracks = 0;
END;


----------------------------------------------------------------------------------------------------
-- [PLAYLIST] 추가, 수정, 삭제 처리
----------------------------------------------------------------------------------------------------




-- [PlaylistMediaRelation]
CREATE TRIGGER update_playlist_order_on_insert
	AFTER INSERT ON PlaylistMediaRelation
	WHEN new.position IS NOT NULL
BEGIN
	UPDATE PlaylistMediaRelation SET position = position + 1
		WHERE playlist_id = new.playlist_id
			AND position = new.position
			AND file_id != new.file_id;
END;

CREATE TRIGGER append_new_playlist_record
	AFTER INSERT ON PlaylistMediaRelation
	WHEN new.position IS NULL
BEGIN
	UPDATE PlaylistMediaRelation
		SET position = (SELECT COUNT(file_id) FROM PlaylistMediaRelation WHERE playlist_id = new.playlist_id)
		WHERE playlist_id=new.playlist_id AND file_id = new.file_id;
END;



CREATE TRIGGER update_playlist_order
	AFTER UPDATE OF position ON PlaylistMediaRelation
BEGIN
	UPDATE PlaylistMediaRelation
		SET position = position + 1
		WHERE playlist_id = new.playlist_id
			AND position = new.position
			AND file_id != new.file_id;
END;


CREATE TRIGGER decrement_media_nb_playlist AFTER DELETE ON  PlaylistMediaRelation
BEGIN
	UPDATE Media SET nb_playlists = nb_playlists - 1
		WHERE file_id = old.file_id;
END;



CREATE TRIGGER increment_media_nb_playlist AFTER INSERT ON  PlaylistMediaRelation
BEGIN
	UPDATE Media SET nb_playlists = nb_playlists + 1
		WHERE file_id = new.file_id;
END;

